<?php
// +----------------------------------------------------------------------
// | 管理员操作日志查询
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;
use app\admin\model\AuthAdmin as Admin;

class admin_action_log extends _Admin
{
   
    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        if (\think\facade\Request::isAjax()) {
            return $this->showlist($param);
        }
       
        $this->assign('id', !empty($param['id']) ? $param['id'] : 0);
        return $this->fetch('auth/admin/action_log');
    }

    // 列表
    private function showlist($param=[]) {
        // 管理员操作日志-分表存储-方式为hash管理员ID
        $SubTable = \org\SubTable::init('auth_admin_action');

        $where = $this->_where($param);

        // 指定管理员日志查询
        if (!empty($param['id'])) {        
            $table = $SubTable->hash($param['id']);
            $list = \think\Db::name($table)->alias('A')->join('auth_admin B', 'A.admin = B.id')->field('A.*, B.nick')->where($where)->order('A.id DESC')->page($param['page'])->limit($param['limit'])->select();
            $count = \think\Db::name($table)->alias('A')->join('auth_admin B', 'A.admin = B.id')->where($where)->count();
        } else {

            // 获得所有子表
            $table_list = $SubTable->get_tables();
            $union = [];

            // 子表构造
            foreach ($table_list as $v) {
                $union[] = \think\Db::name($v)->where($where)->buildSql();
            }

            // 最终使用主表合并查询
            $sql = \think\Db::name('auth_admin_action')->where($where)->union($union)->buildSql();
            $list = \think\Db::table($sql)->alias('A')->join('auth_admin B', 'A.admin = B.id')->field('A.*, B.nick')->order('A.id DESC')->page($param['page'])->limit($param['limit'])->select();
            $count = \think\Db::table($sql)->alias('A')->join('auth_admin B', 'A.admin = B.id')->count();
        }
        
        return self::_list('0', '', $count, $list);
    }

    // 搜索条件
    private function _where($param=[]) {
        $where = [];

        // 指定管理员日志查询
        if (!empty($param['id'])) {
            $where['A.admin'] = ['=', $param['id']];
        }

        if (self::isset_empty($param, 'msg')) {
            $where[] =  ['A.msg','like', "%".$param['msg']."%"];
        }
        if (self::isset_empty($param, 'name')) {
            $where[] = ['A.url','like', "%".$param['url']."%"];
        }
        return $where;
    }

}
