<?php
// +----------------------------------------------------------------------
// | 权限菜单查询
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\admin\controller\Auth;

use app\common\controller\_Admin;
use app\admin\model\AuthMenu as Menu;

class menu_list extends _Admin
{
   
    // 默认留空即可
    protected function initialize()
    {
        parent::initialize();
    }

    // 统一返回方法
    // $param 必留，用于接收get、post的参数传递
    public function run($param=[], $_this) {
        if (\think\facade\Request::isAjax()) {
            return $this->showlist($param);
        }
        return $this->fetch('auth/menu/list');
    }

    // 菜单列表
    private function showlist($param=[]) {
        $where = $this->_where($param);
        $list = Menu::all(function ($query) use($where,$param){
            $query->where($where)->order('path ASC')->page($param['page'])->limit($param['limit']);
        });
        $count = Menu::where($where)->count();
        foreach ($list as $k=>$v) {
            $list[$k]['status'] = $v['status']==1?'开启':'关闭';
            $list[$k]['display'] = $v['display']==1?'显示':'隐藏';
            $list[$k]['public'] = $v['public']==1?'公共':'过滤';
            $nbsp = '';
            for ($i=1; $i<$v['level']; $i++) {
                $nbsp .= '&nbsp;&nbsp;';
            }
            if (!empty($nbsp)) {
                $list[$k]['name'] = $nbsp.'├─'.$v['name'];
            }
        }
        return self::_list('0', '', $count, $list);
    }

    // 搜索条件
    private function _where($param=[]) {
        $where = [];
        if (self::isset_empty($param, 'name')) {
            $where['name'] = $param['name'];
        }
        if (self::isset_empty($param, 'controller')) {
            $where['controller'] = $param['controller'];
        }
        if (self::isset_empty($param, 'action')) {
            $where['action'] = $param['action'];
        }

        return $where;
    }

}
