<?php
// +----------------------------------------------------------------------
// | 3、心跳检测回复
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\action;
use think\Db;

class heartbeat {
   
    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @param swoole $ws 实例
     * @param swoole $request 请求体信息
     * @param array $param 数据包
     * @return void
    */
    public static function run($ws, $request, $param=[]) {
        # 获取redis数据
        $heartbeat =  $ws->redis->hget($ws->config['websocket_redis_table'].$request->fd, 'heartbeat');
        if ($heartbeat !== false) {
            # 更新redis
            $ws->redis->hset($ws->config['websocket_redis_table'].$request->fd, 'heartbeat', 0);
            \app\socket\controller\callback\heartbeat_ok::run($ws, $request->fd, '心跳正常');
        } else {
            \app\socket\controller\callback\error::run($ws, $request->fd, '接口错误');
        }
    }
    
    /**
     * 该接口文档说明
     * @author 小黄牛
     * @version v1.0.1 + 2020.02.24
    */
    public function _link() {
        return [
            // 请求参数
            'param' => [
            ],
            // 返回值
            'return' => [
                // 状态码囊括
                'action' => [
                    'heartbeat_ok' => '心跳正常', 
                    'error' => '接口错误',
                ]
            ]
        ];
    }
}
