<?php
// +----------------------------------------------------------------------
// | 1、登录
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\action;
use think\Db;

class login {
   
    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @param swoole $ws 实例
     * @param swoole $request 请求体信息
     * @param array $param 数据包
     * @return void
    */
    public static function run($ws, $request, $param=[]) {
        # 获取请求头信息
        $headers = $ws->getClientInfo($request->fd);
        # 判断信息
        if (empty($param['phone'])) {
            \app\socket\controller\callback\error::run($ws, $request->fd, '请输入手机号');
            return false;
        }
        if (empty($param['password'])) {
            \app\socket\controller\callback\error::run($ws, $request->fd, '请输入密码');
            return false;
        }
        # 登录操作
        $user = Db::name('user')->where('phone', $param['phone'])->find();
        if (!$user) {
            \app\socket\controller\callback\error::run($ws, $request->fd, '手机号或密码错误');
            return false;
        }
        if ($user['password'] != md5($param['password'].$user['create_time'])) {
            \app\socket\controller\callback\error::run($ws, $request->fd, '手机号或密码错误');
            return false;
        }
        if ($user['is_status'] == 0) {
            \app\socket\controller\callback\error::run($ws, $request->fd, '该账号已被禁用');
            return false;
        }
        # 登录成功，修改数据
        Db::startTrans();
        try {
            Db::name('user')->where('id', $user['id'])->update([
                'is_work_status' => 1,
                'client_fd' => $request->fd,
                'last_login_time' => time(),
                'last_login_ip' => $headers['remote_ip']
            ]);
            Db::commit();
        } catch (\Exception $e) {
            Db::rollback();
            \app\socket\controller\callback\error::run($ws, $request->fd, '服务器异常');
            return false;
        }
        # 更新swoole缓存信息
        # 加入内存存储器-常用的静态数据放这里
        $ws->user->set($user['id'], [
            'fd'        => $request->fd, # FD
            'id' 		=> $user['id'], # 用户ID
        ]);
        # 加入redis-常用的动态数据放这里
        $ws->redis->hmset($ws->config['websocket_redis_table'].$request->fd, [
            'fd'        => $request->fd, # FD
            'id' 		=> $user['id'], # 用户ID
            'status'    => 1, # 设置上线状态
            'heartbeat' => 0, # 重置心跳重连数
        ]);
        # 推送上线消息
        \app\socket\controller\callback\success::run($ws, $request->fd, '登录成功');
    }
    
    /**
     * 该接口文档说明
     * @author 小黄牛
     * @version v1.0.1 + 2020.02.24
    */
    public function _link() {
        return [
            // 请求参数
            'param' => [
                // 参考格式
                'phone' => '15992431677', // 手机号 string(32) 默认null 不为空
                'password' => '123456', // 密码 string(32) 默认null 不为空
            ],
            // 返回值
            'return' => [
                // 状态码囊括
                'action' => [
                    'success' => '请求成功', 
                    'error' => '接口错误',
                ]
            ]
        ];
    }
}
