<?php
// +----------------------------------------------------------------------
// | 商品添加
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\api\shop;
use think\Db;

class insert {
   
    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @param swoole $ws 实例
     * @param swoole $request 请求体信息
     * @param response $response 请求内容 来源类实例也在里面
     * @return void
    */
    public static function run($ws, $request, $response) {
        # 获取请求参数，不区分请求类型，POST优先
        $param = $response->class->param($request);
        # 可以这样判断请求类型
        if ($request->server['request_method'] != 'POST') {
            # 如果需要返回消息，可以这样
            $response->class->endRequest($request, $response, '301', '请求类型错误');
            # 注意，在接口中不能exit，否则会报错的
            return false;
        }
        if (empty($param['fd'])) {
            $response->class->endRequest($request, $response, '301', '请输入fd参数，否则无法推送给指定用户');
            return false;
        }

        # 如果需要给某个用户推送事件，只能调用callback下的消息类，这是为了确保返回体一致做的限制
        # 例如这样
        $res = \app\socket\controller\callback\success::run($ws, $param['fd'], $param['msg'], $param['data']);
        if ($res !== false) {
            $response->class->endRequest($request, $response, '200', '消息发送成功');
            return true;
        }
        $response->class->endRequest($request, $response, '500', '发送失败');
        return false;
    }
    
    /**
     * 该接口文档说明
     * @author 小黄牛
     * @version v1.0.1 + 2020.02.24
    */
    public function _link() {
        return [
            // 请求头
            'header' => [
                'method' => 'POST', // 请求类型
                'code' => 'utf-8', // 内容编码
                'content-type' => 'application/x-www-form-urlencoded', // 数据类型
                // 其余自定义header
            ],
            // 请求参数
            'param' => [
                // 参考格式
                'phone' => '15992431677', // 手机号 string(32) 默认null 不为空
                'password' => '123456', // 密码 string(32) 默认null 不为空
            ],
            // 返回值
            'return' => [
                // 状态码囊括
                'code' => [
                    '200' => '请求正常', 
                    '301' => '错误提示', 
                    '500' => '服务器错误',
                ],
                // data部分返回值说明
                'data' => [
                ]
            ]
        ];
    }
}
