<?php
// +----------------------------------------------------------------------
// | 心跳重连发起
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\crontab;
use think\Db;

class heartbeat {

    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public static function run($ws) {
        /**
         * ⑤服务端强制心跳检测
        */
        swoole_timer_tick($ws->config['websocket_outime_heartbeat'] * 1000, function ($timer_id) use ($ws) {
            foreach ($ws->user as $k=>$user) {
                # 推送心跳重连信号
                \app\socket\controller\callback\heartbeat::run($ws, $user['fd'], '心跳提醒');
                # 获取redis数据
                $heartbeat =  $ws->redis->hget($ws->config['websocket_redis_table'].$user['fd'], 'heartbeat');
                # 心跳次数+1
                $heartbeat += 1;
                # 心跳次数大于等于_max && 在线的 的 连接关闭
                if ($ws->config['websocket_max_heartbeat'] < $heartbeat) {
                    # 修改数据
                    Db::startTrans();
                    try {
                        Db::name('user')->where('id', $user['id'])->update([
                            'is_work_status' => 3,
                            'client_fd' => ''
                        ]);
                        Db::commit();
                    } catch (\Exception $e) {
                        Db::rollback();
                    }
                    # 更新swoole缓存信息
                    # 销毁内存存储器
                    $ws->user->del($user['id']);
                    # 销毁redis
                    $ws->redis->hdel($ws->config['websocket_redis_table'].$user['fd']);
                    # 推送下线消息
                    \app\socket\controller\callback\drop_line::run($ws, $user['fd'], '您已掉线，请重新登录');
                    # 销毁连接
                    $ws->close($user['fd']);
                } else {
                    # 更新redis
                    $ws->redis->hset($ws->config['websocket_redis_table'].$user['fd'], 'heartbeat', $heartbeat);
                }
            }
        });
    }
}
