<?php
// +----------------------------------------------------------------------
// | 监听客户端退出事件
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\event;
use think\Db;

class onClose {
    /**
	 * WS的启动实例
	*/
    public $_ws;
    
    // 构造函数
    public function __construct($ws) {
        $this->_ws = $ws;
    }
    
    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function run($ws, $fd) {
        # 获取redis数据
        $user_id =  $ws->redis->hget($ws->config['websocket_redis_table'].$fd, 'id');
        # 如果还存在数据，则表示是客户端不经过接口，自动端口连接的，这时候要做最后一道防线，清除在线资料
        if ($user_id) {
            # 修改数据
            Db::startTrans();
            try {
                Db::name('user')->where('id', $user['id'])->update([
                    'is_work_status' => 0,
                    'client_fd' => ''
                ]);
                Db::commit();
            } catch (\Exception $e) {
                Db::rollback();
            }
            # 更新swoole缓存信息
            # 销毁内存存储器
            $ws->user->del($user_id);
            # 销毁redis
            $ws->redis->hdel($ws->config['websocket_redis_table'].$fd);
        }
    }
    
}
