<?php
// +----------------------------------------------------------------------
// | 监听WebSocket握手申请
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\event;

class onOpen {
    /**
	 * WS的启动实例
	*/
    public $_ws;
    
    // 构造函数
    public function __construct($ws) {
        $this->_ws = $ws;
    }

    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function run($ws, $request) {
        // 获取参数
        $param = $request->get;
        // 参数过滤
        $res = $this->_param($param, $request->fd);
        if (!$res) return false;
        // 参数鉴权
        $res = $this->_sign_check($param, $request->fd);
        if (!$res) return false;
        // 返回消息
        \app\socket\controller\callback\success::run($this->_ws, $request->fd);
    }
    
    /**
     * 参数过滤
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.19
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function _param($param, $fd) {
        // IP
        if (empty($param['ip'])) {
            $this->_ws->close($fd); 
            return false;
        }
        // 握手时间
        if (empty($param['open_time'])) {
            $this->_ws->close($fd); 
            return false;
        }
        // 设备号
        if (empty($param['device_number'])) {
            $this->_ws->close($fd); 
            return false;
        }
        // 来源
        if (empty($param['source'])) {
            $this->_ws->close($fd); 
            return false;
        }
        // 加密签名
        if (empty($param['sign'])) {
            $this->_ws->close($fd); 
        } 
        return true;
    }

    /**
     * 参数鉴权
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.19
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function _sign_check($param, $fd) {
        $str = $param['ip'].$param['open_time'].$param['device_number'].$param['source'];
        $md5 = md5($str);
        $base64 = base64_encode($md5);
        $sign = md5($base64);
        
        // 签名对比
        if ($param['sign'] != $sign) {
            $this->_ws->close($fd); 
        }

        return true;
    }
}
