<?php
// +----------------------------------------------------------------------
// | 监听WebSocket进程启动
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\event;

class onStart {
    /**
	 * WS的启动实例
	*/
    public $_ws;
    
    // 构造函数
    public function __construct($ws) {
        $this->_ws = $ws;
    }

    /**
     * 统一入口
     * @todo 无
     * @author 小黄牛
     * @version v1.0.9 + 2020.04.16
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    public function run($server) {
        // 这里需要注意，只有在第一次启动服务时，才会进入该流程
        
        // 设置进程别名
        swoole_set_process_name($this->_ws->config['websocket_api_process_name']);
        
        // 自动载入所有定时任务
        // 不能在onWorkerStart事件中载入，因为进程重启会导致重复启动定时任务
        $path = dirname(dirname(__FILE__)).'/crontab/';
        $filename = scandir($path);
        foreach($filename as $k=>$v){
            if ($v=="." || $v=="..") continue;
            // 载入定时器
            $class = '\app\socket\controller\crontab\\'.substr($v,0,strpos($v,"."));
            $class::run($this->_ws);
        }
    }
    
}

