<?php
// +----------------------------------------------------------------------
// | 工具类
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace app\socket\controller\vendor;
use think\facade\Config;

class Tool {

    //获取配置文件
    public static function get_config() {
        return Config::pull('laf');
    }
    
    /** 
     * AES加密方法，对数据进行加密，返回加密后的数据 
     * @param string $data 要加密的数据 
     * @return string 
     */  
    public static function encrypt($data) {  
        $_config = self::get_config();
        return openssl_encrypt($data, $_config['websocket_aes_type'], $_config['websocket_aes_key'], 0, $_config['websocket_aes_iv']);  
    }  
  
    /** 
     * AES解密方法，对数据进行解密，返回解密后的数据 
     * @param string $data 要解密的数据 
     * @return string 
     */  
    public static function decrypt($data) {  
        $_config = self::get_config();
        return openssl_decrypt($data, $_config['websocket_aes_type'], $_config['websocket_aes_key'], 0, $_config['websocket_aes_iv']);  
    } 

    /**
     * 获取参数
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1 + 2020.1.13
     * @deprecated 暂不启用
     * @global 无
     * @param void $data
     * @param array $_config 配置项
     * @return void
    */
    public static function get_data($data, $_config) {
        // 启用加密方式
        if ($_config['websocket_aes_key']) {
            $data = self::decrypt($data);
        }
        return json_decode($data, true);
    }

    /**
     * 发送数据包
     * @todo 无
     * @author 小黄牛
     * @version v1.0.1 + 2020.1.13
     * @deprecated 暂不启用
     * @global 无
     * @param Swoole $ws 实例
     * @param string $fd 推送标记
     * @param string $msg 说明
     * @param mixed $data 结果集
     * @return void
    */
    public static function ajaxReturn($ws, $fd, $msg='success', $data=[]) {
        $row = current(debug_backtrace());
        $action = basename($row['file'],".php");
        $_config = self::get_config();
        $array = [
            'action' => $action,
            'msg' => $msg,
            'data' => $data
        ];
        $content = json_encode($array, JSON_UNESCAPED_UNICODE);

        // 启用加密方式
        if ($_config['websocket_aes_key']) {
            $content = self::encrypt($content);
        }

        try {
            return $ws->push($fd, $content);
        } catch (\Exception $e) {
            return false;
        }
    } 
}
