<?php
// +----------------------------------------------------------------------
// | ThinkPHP [ WE CAN DO IT JUST THINK ]
// +----------------------------------------------------------------------
// | Copyright (c) 2006~2018 http://thinkphp.cn All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: liu21st <liu21st@gmail.com>
// +----------------------------------------------------------------------

// +----------------------------------------------------------------------
// | 微信相关配置
// +----------------------------------------------------------------------

return [
    // 消息加解密方式 1【明文模式】 2【兼容模式，安全模式】
    'token_type' => 1,
    // TOKEN
    'token' => '',
    // EncodingAESKey
    'EncodingAESKey' => '', 
    // appid
    'appid' => '',
    // AppSecret
    'appsecret' => '',
    // access_token有效期(S)
    'access_token_outtime' => 120,
    // 用户信息返回结果语言版本 zh_CN 简体，zh_TW 繁体，en 英语
    'web_lang' => 'zh_CN',
    // 商户ID
    'mch_id' => '',
    // 支付key
    'pay_key' => '',


    //--------------------------------------------所有API请求地址汇总----使用占位符%s%代替参数----------------------------------------//
    // 获取普通access_token
    'access_token' => 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=%s%&secret=%s%',
    // 发送消息模板
    'industry_send' => 'https://api.weixin.qq.com/cgi-bin/message/template/send?access_token=%s%',
    // 长链接转短链接接口
    'short_url' => 'https://api.weixin.qq.com/cgi-bin/shorturl?access_token=%s%',
    
    //--------------------------------------------菜单相关----------------------------------------//
    # 创建菜单
    'menu_insert' => 'https://api.weixin.qq.com/cgi-bin/menu/create?access_token=%s%',
    # 删除菜单
    'menu_delete' => 'https://api.weixin.qq.com/cgi-bin/menu/delete?access_token=%s%',
    # 查询菜单
    'menu_list' => 'https://api.weixin.qq.com/cgi-bin/menu/get?access_token=%s%',

    //--------------------------------------------用户相关----------------------------------------//
    # 通过OpenID来获取用户基本信息（包括UnionID机制）
    'basic' => 'https://api.weixin.qq.com/cgi-bin/user/info?access_token=%s%&openid=%s%',
    # 通过OpenID设置用户备注名
    'remarks' => 'https://api.weixin.qq.com/cgi-bin/user/info/updateremark?access_token=%s%',
    # 通过OpenId获取用户列表
    'user_list' => 'https://api.weixin.qq.com/cgi-bin/user/get?access_token=%s%&next_openid=%s%',
    # 点击授权的生成链接 state参数虽然为可选，但还是建议必填
    'snsapi' => 'https://open.weixin.qq.com/connect/oauth2/authorize?appid=%s%&redirect_uri=%s%&response_type=code&scope=%s%&state=%s%#wechat_redirect',
    # 用授权后获得code去换取特殊的Access_Token
    'snsapi_access_token' => 'https://api.weixin.qq.com/sns/oauth2/access_token?appid=%s%&secret=%s%&code=%s%&grant_type=authorization_code',
    # 使用refresh_token更新特殊的Access_Token
    'snsapi_update_access_token' => 'https://api.weixin.qq.com/sns/oauth2/refresh_token?appid=%s%&grant_type=refresh_token&refresh_token=%s%',
    # 使用特殊的Access_Token去获取用户信息
    'snsapi_user_info' => 'https://api.weixin.qq.com/sns/userinfo?access_token=%s%&openid=%s%&lang=%s%',

    //--------------------------------------------普通二维码相关----------------------------------------//
    # 创建二维码的ticket
    'qrcode' => 'https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token=%s%',
    # 使用ticket去换取二维码
    'qrcode_ticket' => 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=%s%',

    /******************************* 微信支付相关 ******************************/
    'wx_pay_url' => 'https://api.mch.weixin.qq.com/pay/unifiedorder',
    # 扫码模式一 生成二维码地址
    'ScanCode_One_Url' => 'weixin://wxpay/bizpayurl?sign=%s%&appid=%s%&mch_id=%s%&product_id=%s%&time_stamp=%s%&nonce_str=%%',
];