<?php
// +----------------------------------------------------------------------
// | 微信开发基类
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace wx;
use think\facade\Config;

class Weixins {
    protected static $config = [];

    // 读取配置文件
    protected static function get_config() {
        self::$config = Config::pull('weixin');
    }

    /**
     * 将参数植入占位符
     * @todo 占位符为%s%
     * @author 小黄牛
     * @version v1.0.0.4 + 2018.10.11
     * @deprecated 暂不弃用
     * @global 无
     * @param string $url 占位字符串
     * @param array $array 参数是一维数组，参数需要自行按照占位符排序排列
     * @return string 格式化后的字符串
    */
    protected static function str_url($url, $array){
        # 循环替换占位内容
        foreach ($array as $v){
            $url = preg_replace('/%s%/', $v, $url, 1);
        }
        return $url;
    }

    /**
     * 对于微信支付金额进行小数转换
     * @todo 单位是 分
     * @author 小黄牛
     * @version v1.0.0.4 + 2018.10.11
     * @deprecated 暂不弃用
     * @global 无
     * @param string $money 金额
     * @return void 返回转换后的金额
    */
	protected static function money($money){
		if(floor($money) != $money){
            # 只保留2位小数，并且不做四舍五入
            $money = sprintf("%.2f",substr(sprintf("%.3f", $money), 0, -1));
            # 删除小数点
			$money = str_replace('.', '', $money);
		}
		return $money;
    }
    
    /**
     * 微信接口数据传输的万能函数
     * @todo 无
     * @author 小黄牛
     * @version v1.0.0.4 + 2018.10.11
     * @deprecated 暂不弃用
     * @global 无
     * @param string $url 请求地址
     * @param mixed $data 请求参数，默认为空
     * @return mixed 请求返回内容
    */
	protected static function https_curl($url, $data = null){
		$curl = curl_init();

		curl_setopt($curl, CURLOPT_URL, $url);
		curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
		curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);

		if (!empty($data)){
			curl_setopt($curl, CURLOPT_POST, 1);
			curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
		}

		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		$response = curl_exec($curl);
		curl_close($curl);
		return $response;
    }
}