<?php
// +----------------------------------------------------------------------
// | 获取普通actoekn
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace wx\sdk;

use wx\Weixins;
use think\facade\Cache;

class access_token extends Weixins{
    // 普通actoken的key
    private static $cache_key = 'access_token';
    // 普通actoken的time-key
    private static $cache_time_key = 'access_token_time';
    
    /**
     * 获取ACTOKEN
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @return void
    */
	public static function get(){   
        self::get_config();
        if (Cache::get(self::$cache_key)) {
            //dump(date('Y-m-d H:i:s', Cache::get(self::$cache_time_key)));
            //dump(date('Y-m-d H:i:s', time()));
            // 最后加一层保险，防止无端端无效
            if (Cache::get(self::$cache_time_key) <= time()) {
                $res = self::create();
                if (!$res) return false;
            }
            return Cache::get(self::$cache_key);
        }

        $res = self::create();
        if (!$res) return false;
        
        return Cache::get(self::$cache_key);
    }

    /**
     * 创建缓存
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不启用
     * @global 无
     * @return void
    */
    private static function create() {
        # 请求ToKen
		$res = self::https_curl(self::str_url(self::$config['access_token'], [
			self::$config['appid'],
			self::$config['appsecret']
        ]));
		# 接受一个 JSON 格式的字符串并且把它转换为 PHP 变量
        $result = json_decode($res, true);
        if (empty($result['access_token'])) {
            \log\Log::init()->insert('access_token请求失败：'.$res, 'error');
            return false;
        }
        # 写入缓存
        Cache::set(self::$cache_time_key, time()+self::$config['access_token_outtime'], 3600);
        return Cache::set(self::$cache_key, $result['access_token'], self::$config['access_token_outtime']);
    }
}