<?php
// +----------------------------------------------------------------------
// | 微信支付相关
// +----------------------------------------------------------------------
// | Copyright (c) 2018 https://blog.junphp.com All rights reserved.
// +----------------------------------------------------------------------
// | Licensed ( http://www.apache.org/licenses/LICENSE-2.0 )
// +----------------------------------------------------------------------
// | Author: 小黄牛 <1731223728@qq.com>
// +----------------------------------------------------------------------

namespace wx\sdk;

use wx\Weixins;
use think\facade\Request;

class pay extends Weixins{
    
    /**
     * 小程序 / JSAPI
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @param $notify_url 回调地址
     * @param $openid OpenID
     * @param $money 订单金额
     * @param $order_sn 订单号
     * @param $body 支付标题
     * @return void
    */
	public static function wx($notify_url, $openid, $money, $order_sn=null, $body='订单支付'){
        self::get_config();
        if (!$order_sn) $order_sn = self::getOrderSN();
        
        $nonce_str = (string)rand(10000, 99999).time();//随机字符串 

        //这里是按照顺序的 因为下面的签名是按照(字典序)顺序 排序错误 肯定出错 
        $post = [];
        $post['appid'] = self::$config['appid']; 
        $post['body'] = $body;
        $post['mch_id'] =self::$config['mch_id']; 
        $post['nonce_str'] = $nonce_str;//随机字符串 
        $post['notify_url'] = $notify_url; 
        $post['openid'] = $openid; 
        $post['out_trade_no'] = $order_sn; 
        $post['spbill_create_ip'] = $_SERVER['SERVER_ADDR'];//服务器终端的ip 
        $post['total_fee'] = intval($money*100); //总金额 最低为一分钱 必须是整数 
        $post['trade_type'] = 'JSAPI';//交易类型 默认JSAPI 
        $sign = self::MakeSign($post, self::$config['pay_key']); //签名 
		$post_xml = '<xml> <appid>'.$post['appid'].'</appid>
			<body>'.$post['body'].'</body>
			<mch_id>'.$post['mch_id'].'</mch_id>
			<nonce_str>'.$post['nonce_str'].'</nonce_str>
			<notify_url>'.$post['notify_url'].'</notify_url>
			<openid>'.$post['openid'].'</openid>
			<out_trade_no>'.$post['out_trade_no'].'</out_trade_no>
			<spbill_create_ip>'.$post['spbill_create_ip'].'</spbill_create_ip>
			<total_fee>'.$post['total_fee'].'</total_fee>
			<trade_type>'.$post['trade_type'].'</trade_type>
			<sign>'.$sign.'</sign></xml>'; 

        $xml = self::https_curl(self::$config['wx_pay_url'], $post_xml);
        $res = self::xml2array($xml); //将【统一下单】api返回xml数据转换成数组，全要大写 

        if($res['return_code'] != 'SUCCESS' || $res['return_code'] != 'SUCCESS' || !empty($res['err_code_des'])){
            if (!empty($res['err_code_des'])) {
                \log\Log::init()->insert('请求错误：'.$res['err_code_des'], 'error');
            }  else {
                \log\Log::init()->insert('请求错误：'.$res['return_msg'], 'error');
            }
            return false;
        } 

        $time = time(); 
        $data = []; //临时数组用于签名 
        $data['appId'] = self::$config['appid']; 
        $data['timeStamp'] = "$time"; //时间戳 
        $data['nonceStr'] = $post['nonce_str']; //随机字符串 
        $data['signType'] = 'MD5'; //签名算法，暂支持 MD5 
        $data['package'] = 'prepay_id='.$res['prepay_id'];
        $data['paySign'] = self::MakeSign($data, self::$config['pay_key']);
        
        \log\Log::init()->insert('请求成功：'.json_encode($data));

        return $data;
    }

    /**
     * H5
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @param $notify_url 回调地址
     * @param $money 订单金额
     * @param $order_sn 订单号
     * @param $wap_url 取消支付回跳地址
     * @param $body 支付标题
     * @return void
    */
	public static function h5($notify_url, $money, $order_sn=null, $wap_url='', $body='订单支付'){
        self::get_config();
        if (!$order_sn) $order_sn = self::getOrderSN();
        if (!$wap_url) $wap_url = Request::root(true);

        //这里是按照顺序的 因为下面的签名是按照(字典序)顺序 排序错误 肯定出错 
        $appid            = self::$config['appid']; 
        $body             = $body;
        $mch_id           = self::$config['mch_id']; 
        $key              = self::$config['pay_key']; 
        $nonce_str        = (string)rand(10000, 99999).time();//随机字符串 
        $notify_url       = $notify_url; 
        $out_trade_no     = $order_sn; 
        $spbill_create_ip = $_SERVER['SERVER_ADDR'];//服务器终端的ip 
        $total_fee        = intval($money*100); //总金额 最低为一分钱 必须是整数 
        $trade_type       = 'MWEB';//交易类型
        $scene_info       = '{"h5_info":{"type":"Wap","wap_url":"'.$wap_url.'","wap_name":"'.$body.'"}}';

        $signA ="appid=$appid&body=$body&mch_id=$mch_id&nonce_str=$nonce_str&notify_url=$notify_url&out_trade_no=$out_trade_no&scene_info=$scene_info&spbill_create_ip=$spbill_create_ip&total_fee=$total_fee&trade_type=$trade_type";
		$strSignTmp = $signA."&key=$key";
        $sign = strtoupper(MD5($strSignTmp));
        $post_xml="<xml><appid>$appid</appid><body>$body</body><mch_id>$mch_id</mch_id><nonce_str>$nonce_str</nonce_str><notify_url>$notify_url</notify_url><out_trade_no>$out_trade_no</out_trade_no><scene_info>$scene_info</scene_info><spbill_create_ip>$spbill_create_ip</spbill_create_ip><total_fee>$total_fee</total_fee><trade_type>$trade_type</trade_type><sign>$sign</sign></xml>";//拼接成XML格式 *XML格式文件要求非常严谨不能有空格这点一定要注意
        
        $xml = self::https_curl(self::$config['wx_pay_url'], $post_xml);
        $res = self::xml2array($xml); //将【统一下单】api返回xml数据转换成数组，全要大写 

        if($res['return_code'] != 'SUCCESS' || $res['return_code'] != 'SUCCESS' || !empty($res['err_code_des'])){
            if (!empty($res['err_code_des'])) {
                \log\Log::init()->insert('请求错误：'.$res['err_code_des'], 'error');
            }  else {
                \log\Log::init()->insert('请求错误：'.$res['return_msg'], 'error');
            }
            return false;
        } 

        \log\Log::init()->insert('请求成功：'.json_encode($res));
        return $res['mweb_url'];
    }

    
    /**
     * 二维码
     * @todo 无
     * @author 小黄牛
     * @version v1.0.8 + 2020.04.10
     * @deprecated 暂不弃用
     * @global 无
     * @param $notify_url 回调地址
     * @param $money 订单金额
     * @param $order_sn 订单号
     * @param $body 支付标题
     * @return void
    */
	public static function qrcode($notify_url, $money, $order_sn=null, $body='订单支付'){
        self::get_config();
        if (!$order_sn) $order_sn = self::getOrderSN();

        $nonce_str = (string)rand(10000, 99999).time();//随机字符串 

        $config = [
            'mch_id' => self::$config['mch_id'],
            'appid' => self::$config['appid'],
            'key' => self::$config['pay_key']
        ];
        
        //这里是按照顺序的 因为下面的签名是按照(字典序)顺序 排序错误 肯定出错 
        $post = [];
        $post['appid'] = self::$config['appid']; 
        $post['body'] = '订单支付';
        $post['mch_id'] =self::$config['mch_id']; 
        $post['nonce_str'] = $nonce_str;//随机字符串 
        $post['notify_url'] = $notify_url; 
        $post['out_trade_no'] = $order_sn; 
        $post['spbill_create_ip'] = $_SERVER['SERVER_ADDR'];//服务器终端的ip 
        $post['total_fee'] = intval($money*100); //总金额 最低为一分钱 必须是整数 
        $post['trade_type'] = 'NATIVE';//交易类型 默认JSAPI 
        $sign = self::MakeSign($post, self::$config['pay_key']); //签名 

		$post_xml = '<xml> <appid>'.$post['appid'].'</appid>
			<body>'.$post['body'].'</body>
			<mch_id>'.$post['mch_id'].'</mch_id>
			<nonce_str>'.$post['nonce_str'].'</nonce_str>
			<notify_url>'.$post['notify_url'].'</notify_url>
			<out_trade_no>'.$post['out_trade_no'].'</out_trade_no>
			<spbill_create_ip>'.$post['spbill_create_ip'].'</spbill_create_ip>
			<total_fee>'.$post['total_fee'].'</total_fee>
			<trade_type>'.$post['trade_type'].'</trade_type>
			<sign>'.$sign.'</sign></xml>'; 

        $xml = self::https_curl(self::$config['wx_pay_url'], $post_xml);
        $res = self::xml2array($xml); //将【统一下单】api返回xml数据转换成数组，全要大写 

        if($res['return_code'] != 'SUCCESS' || $res['return_code'] != 'SUCCESS' || !empty($res['err_code_des'])){
            if (!empty($res['err_code_des'])) {
                \log\Log::init()->insert('请求错误：'.$res['err_code_des'], 'error');
            }  else {
                \log\Log::init()->insert('请求错误：'.$res['return_msg'], 'error');
            }
            return false;
        } 
        if (empty($res['code_url'][0])) {
            \log\Log::init()->insert('请求错误：'.json_encode($res), 'error');
            return false;
        }
        
        $time = time(); 
        $data = []; //临时数组用于签名 
        $data['appId'] = self::$config['appid']; 
        $data['timeStamp'] = "$time"; //时间戳 
        $data['nonceStr'] = $post['nonce_str']; //随机字符串 
        $data['signType'] = 'MD5'; //签名算法，暂支持 MD5 
        $data['package']  = 'prepay_id='.$res['prepay_id'];
        $data["code_url"] = $res['code_url'][0];
        $data['paySign'] = self::MakeSign($data, self::$config['pay_key']);
        
        \log\Log::init()->insert('请求成功：'.json_encode($data));

        return $data;
    }


    /**   
     * 生成16位纯数字订单号   
     * 最大支持时间到 2056-12-31 23:59:59   
    */   
    private static function getOrderSN() {  
        return (date('y') + date('m') + date('d')) . str_pad((time() - strtotime(date('Y-m-d'))), 5, 0, STR_PAD_LEFT) . substr(microtime(), 2, 6) . sprintf('%03d', rand(0, 999));   
    }

    //获取xml里面数据，转换成array
	private static function xml2array($xml){ 
        $obj = simplexml_load_string($xml,"SimpleXMLElement", LIBXML_NOCDATA);
        return json_decode(json_encode($obj),true);
    } 
    
    /** * 生成签名, $KEY就是支付key * @return 签名 */ 
    private static function MakeSign($params, $KEY){
		//签名步骤一：按字典序排序数组参数 
		ksort($params); 
		$string = self::ToUrlParams($params); //参数进行拼接key=value&k=v 
		//签名步骤二：在string后加入KEY 
		$string = $string . "&key=".$KEY; 
		//签名步骤三：MD5加密 
		$string = md5($string); 
		//签名步骤四：所有字符转为大写 
		$result = strtoupper($string); 
		return $result; 
    } 
    
	/** * 将参数拼接为url: key=value&key=value * @param $params * @return string */ 
	private static function ToUrlParams( $params ){
		$string = ''; 
		if( !empty($params) ){ 
			$array = array(); 
			foreach( $params as $key => $value ){ 
				$array[] = $key.'='.$value; 
			}
			$string = implode("&",$array);
		} 
		return $string; 
	} 

}